/* tde51d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int de51d_c(U_fp, int *, double *, double *, double *, double *,
                       double *, int *, int *, double *, int *, double *,
                       double *, int *);
    static int ider, imax, ierr;
    extern int f_c();
    static double h__;
    static int i__, n;
    static double x, y[150], delty[150], ck[3], cn[3];
    static int ik;
    static double xk, xn;
    static int nx;
    static double yr[200], yx[150], rab[1650], eps;

    nx = 150;
    xn = 0.;
    xk = 3.141592653589793;
    xk /= 2.;
    cn[0] = 2.;
    cn[1] = -1.;
    cn[2] = 0.;
    ck[0] = 1.;
    ck[1] = 1.;
    ck[2] = -1.;
    imax = 4;
    eps = 1e-5;
    ider = 1;
    i__1 = nx;
    for (i__ = 1; i__ <= i__1; ++i__) {
        yx[i__ - 1] = 1.5;
/* L1: */
    }
    de51d_c((U_fp)f_c, &nx, &xn, &xk, cn, ck, &eps, &imax, &ider, yx, &ik,
            delty, rab, &ierr);

    printf("\n %5i \n", ik);
    printf("\n %5i \n", ierr);
    n = nx - 1;
    h__ = (xk - xn) / (float) n;
    x = xn - h__;
    i__1 = nx;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x += h__;
        y[i__ - 1] = sin(x) + cos(x) * 2.;
        yr[i__ - 1] = yx[i__ - 1] - y[i__ - 1];

        printf("\n %24.14e %24.14e ", x, yx[i__-1]);
        printf("\n   %24.14e %24.14e \n", y[i__-1], yr[i__-1]);
/* L2: */
    }
    return 0;
} /* main */

int f_c(double *fc, double *gc, double *rc,
        double *x, double *y, int *i__, double *rab)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    *fc = *x * rab[*i__];
    *gc = exp(-(*y));
    *rc = (*x * rab[*i__] - 2. + exp(-(*y)) * 2.f) * cos(*x) -
            (*x * 2.f * rab[*i__] + 1.f - exp(-(*y))) * sin(*x);
    return 0;
} /* f_c */
